jQuery( document ).ready( function( $ ) {
	jQuery( '#mainwp-ssl-monitor-automatic-checks' ).change( function() {
		if( this.checked ) {
			jQuery( '#mainwp-ssl-monitor-automatic-checks-toggle-area' ).fadeIn();
		} else {
			jQuery( '#mainwp-ssl-monitor-automatic-checks-toggle-area' ).fadeOut();
		}
	} );

	jQuery( '#mainwp-ssl-monitor-overwrite-general-settings' ).change( function() {
		if( this.checked ) {
			jQuery( '.mainwp-ssl-monitor-overwrite-general-settings-toggle-area' ).fadeIn();
		} else {
			jQuery( '.mainwp-ssl-monitor-overwrite-general-settings-toggle-area' ).fadeOut();
		}
	} );

	jQuery( '.ssl-monitor-action-recheck' ).on( 'click', function() {
		var row = jQuery( this ).closest('tr');
		var site_name = row.find( 'a.mainwp-site-name-link' ).html();
		var columns = jQuery( "#mainwp-ssl-monitor-sites-table" ).find("tr:first th").length;
		var data = {
			action: 'mainwp_ssl_monitor_check_site_certificate',
			websiteId: row.attr( 'website-id' ),
			nonce: mainwpSSLMonitor.nonce
		}

		row.html( '<td></td><td colspan="' + columns + '"><i class="notched circle loading icon"></i> ' + site_name + ' SSL Certificate check in progress. Please wait...</td>' );
		jQuery.post( ajaxurl, data, function( response ) {
			row.removeClass( 'queue' );
			if ( response ) {
				if ( response['error'] ) {
					row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check failed. ' + response['error'] + ' Page will reload in 3 seconds.</td>' );
				} else if (response['status'] == 'success') {
					row.html( '<td></td><td colspan="' + columns + '"><i class="green check icon"></i> ' + site_name + ' SSL Certificate check completed successfully. Page will reload in 3 seconds.</td>' );
				} else {
					row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check failed. Page will reload in 3 seconds.</td>' );
				}
			} else {
				row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check failed. Page will reload in 3 seconds.</td>' );
			}

			setTimeout( function() {
				window.location.reload();
			}, 3000 );

		}, 'json');
	} );

	// Trigger the bulk actions
	jQuery( '#mainwp-ssl-monitor-bulk-actions-button' ).on( 'click', function() {
		var action = jQuery( '#mainwp-ssl-monitor-bulk-actions-menu' ).dropdown( "get value" );
		mainwp_ssl_monitor_bulk_actions_selector( action );
	} );

	// Close modal and reload page.
	jQuery('#mainwp-ssl-monitor-sync-modal .ui.reload.cancel.button').on('click', function () {
		window.location.href = 'admin.php?page=Extensions-Mainwp-Ssl-Monitor-Extension&tab=dashboard';
	});
} );

var ssl_monitor_max_threads = 5;
var ssl_monitor_total_threads = 0;
var ssl_monitor_current_threads = 0;
var ssl_monitor_completed_threads = 0;
var ssl_monitor_errors = 0;

// Manage Bulk Actions
mainwp_ssl_monitor_bulk_actions_selector = function( action ) {
	var selector = '';
	switch ( action ) {
		case 'check-sites':
			selector += '#mainwp-ssl-monitor-sites-table tbody tr';
			jQuery( selector ).addClass( 'queue' );
			mainwp_ssl_monitor_bulk_check_start_next( selector, true );
		break;
		case 'open-wpadmin':
			jQuery( '#mainwp-ssl-monitor-sites-table .check-column INPUT:checkbox:checked' ).each( function () {
				var row = jQuery( this ).closest( 'tr' );
				var url = row.find( 'a.open_newwindow_wpadmin' ).attr( 'href' );
				window.open( url, '_blank' );
			} );
		break;
		case 'open-frontpage':
			jQuery( '#mainwp-ssl-monitor-sites-table .check-column INPUT:checkbox:checked' ).each( function () {
				var row = jQuery( this ).closest( 'tr' );
				var url = row.find( 'a.open_site_url' ).attr( 'href' );
				window.open( url, '_blank' );
			} );
		break;
	}
}

mainwp_ssl_monitor_bulk_check_start_next = function( selector ) {
	if ( ssl_monitor_total_threads == 0 ) {
		ssl_monitor_total_threads = jQuery( '#mainwp-ssl-monitor-sites-table tbody' ).find( 'input[type="checkbox"]:checked' ).length;
	}

	while ( ( item_to_process = jQuery( selector + '.queue:first' ) ) && ( item_to_process.length > 0 ) && ( ssl_monitor_current_threads < ssl_monitor_max_threads ) ) {
		item_to_process.removeClass( 'queue' );
		if ( item_to_process.closest( 'tr' ).find( 'input[type="checkbox"]:checked' ).length == 0 ) {
			continue;
		}
		mainwp_ssl_monitor_bulk_check_start_specific( item_to_process, selector );
	}
}

mainwp_ssl_monitor_bulk_check_start_specific = function( item_to_process, selector ) {
	var row = item_to_process.closest( 'tr' );
	var columns = jQuery( "#mainwp-ssl-monitor-sites-table" ).find("tr:first th").length;
	var site_name = row.find( 'a.mainwp-site-name-link' ).html();
	var bulk = true;

	if ( bulk ) {
		ssl_monitor_current_threads++;
	}

	var data = {
		action: 'mainwp_ssl_monitor_check_site_certificate',
		websiteId: item_to_process.attr( 'website-id' ),
		nonce: mainwpSSLMonitor.nonce
	};

	row.html( '<td></td><td colspan="' + columns  + '"><i class="notched circle loading icon"></i> ' + site_name + ' SSL Certificate check in progress. Please wait...</td>' );

	jQuery.post( ajaxurl, data, function( response ) {
		item_to_process.removeClass( 'queue' );
		if ( response ) {
			if ( response['error'] ) {
				row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check  failed. ' + response['error'] + ' Page will reload in 3 seconds.</td>' );
			} else if ( response['status'] == 'success' ) {
				row.html( '<td></td><td colspan="' + columns + '"><i class="green check icon"></i> ' + site_name + ' SSL Certificate check  completed successfully.</td>' );
			} else {
				row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check  failed. Please try again.</td>' );
			}
		} else {
			row.html( '<td></td><td colspan="' + columns + '"><i class="times red icon"></i> ' + site_name + ' SSL Certificate check  failed. Please try again.</td>' );
		}

		if ( bulk ) {
			ssl_monitor_current_threads--;
			ssl_monitor_completed_threads++;

			mainwp_ssl_monitor_bulk_check_start_next( selector );
		}

		if ( ssl_monitor_total_threads == ssl_monitor_completed_threads ) {
			setTimeout( function() {
				window.location.reload( true );
			}, 3000 );
		}

	}, 'json' );
	return false;
}

// Loop through sites
mainwp_ssl_monitor_start_next = function() {
	mainwp_ssl_monitor_popup_check_next();
};

mainwp_ssl_monitor_popup_check_next = function() {
	if ( ssl_monitor_total_threads == 0 ) {
		ssl_monitor_total_threads = jQuery( '.item[status="queue"]' ).length;
	}

	while ( ( item_to_process = jQuery( '.item[status="queue"]:first' ) ) && ( item_to_process.length > 0 ) && ( ssl_monitor_current_threads < ssl_monitor_max_threads ) ) {
		mainwp_ssl_monitor_popup_check_specific( item_to_process );
	}
};

mainwp_ssl_monitor_popup_check_specific = function( item_to_process ) {

	ssl_monitor_current_threads++;
	item_to_process.attr( 'status', 'progress' );

	var statusEl = item_to_process.find( '.status' ).html( '<span data-tooltip="Checking. Please wait..." data-inverted="" data-position="left center"><i class="notched circle loading icon"></i></span>' );
	var data = {
		action: 'mainwp_ssl_monitor_check_site_certificate',
		websiteId: item_to_process.attr( 'siteid' ),
		nonce: mainwpSSLMonitor.nonce
	};

	jQuery.post( ajaxurl, data, function( response ) {
		item_to_process.attr( 'status', 'done' );
		if ( response ) {
			if ( response['status'] == 'success' ) {
				statusEl.html( '<span data-tooltip="SSL Certificate check completed successfully." data-inverted="" data-position="left center"><i class="green check icon"></i></span>' );
			} else if ( response['error'] ) {
				statusEl.html( '<span data-tooltip="' + response['error'] + '" data-inverted="" data-position="left center"><i class="red times icon"></i></span>' );
				ssl_monitor_errors++;
			} else {
				statusEl.html( '<span data-tooltip="No response from the server. Please try again." data-inverted="" data-position="left center"><i class="red times icon"></i></span>' ).show();
				ssl_monitor_errors++;
			}
		} else {
			statusEl.html( '<span data-tooltip="No response from the server. Please try again." data-inverted="" data-position="left center"><i class="red times icon"></i></span>' );
			ssl_monitor_errors++;
		}

		ssl_monitor_current_threads--;
		ssl_monitor_completed_threads++;

		jQuery( '#mainwp-ssl-monitor-sync-modal .mainwp-modal-progress' ).progress( { value: ssl_monitor_completed_threads, total:  ssl_monitor_total_threads } );
		jQuery( '#mainwp-ssl-monitor-sync-modal .mainwp-modal-progress' ).find( '.label' ).html( ssl_monitor_completed_threads + '/' + ssl_monitor_total_threads + ' ' + __( 'Completed' ) );

		if ( ssl_monitor_completed_threads == ssl_monitor_total_threads ) {
			if ( ssl_monitor_errors == 0 ) {
				jQuery( '#mainwp-ssl-monitor-modal-progress-feedback' ).addClass( 'green' );
				jQuery( '#mainwp-ssl-monitor-modal-progress-feedback' ).html( 'Process completed without errors. Page will reload in 3 seconds.' );
				setTimeout( function() {
					window.location.href = 'admin.php?page=Extensions-Mainwp-Ssl-Monitor-Extension&tab=dashboard';
				}, 3000 );
			} else {
				jQuery( '#mainwp-ssl-monitor-modal-progress-feedback' ).addClass( 'red' );
				jQuery( '#mainwp-ssl-monitor-modal-progress-feedback' ).html( 'Process completed with errors.' );
			}
		}

		mainwp_ssl_monitor_popup_check_next();

	}, 'json');
};